// ==============================================================
// Name:		x2c - msxmlimport.h
//
// Description:	imports the msxml component from the OS
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#ifndef MSXMLIMPORT_H
#define MSXMLIMPORT_H
#pragma message("--- MSXMLImport.h")

#pragma message("- begin includes - " __FILE__)

#import "msxml.tlb"
#include <atlbase.h>
#include <string>

#pragma message("- end includes - " __FILE__)

using std::wstring;

namespace m {

// ----------------------------------------------------------------------- //

typedef		CComQIPtr<MSXML::IXMLDOMNode>			XML_NodePtr;
typedef		CComQIPtr<MSXML::IXMLDOMNodeList>		XML_NodelistPtr;
typedef		CComQIPtr<MSXML::IXMLDOMElement>		XML_ElementPtr;
typedef		CComQIPtr<MSXML::IXMLDOMDocument>		XML_DocumentPtr;
typedef		CComQIPtr<MSXML::IXMLDOMNamedNodeMap>	XML_NamedNodeMapPtr;
typedef		CComQIPtr<MSXML::IXMLDOMParseError>		XML_ParseErrorPtr;

void		SetAttribute(XML_NodePtr pNode, CComBSTR bstrName, int iValue);
void		SetAttribute(XML_NodePtr pNode, CComBSTR bstrName, CComBSTR bstrValue);
void		SetAttribute(XML_NodePtr pNode, CComBSTR bstrName, CComVariant vValue);
void		SetAttribute(XML_NodePtr pNode, const wstring& sName, const wstring& sValue);

void		DelAttribute(XML_NodePtr pNode, const wstring& sName);


XML_NodePtr GetNodeOnAttrib(XML_NodePtr pRoot, CComBSTR bstrName, void* ptr);
XML_NodePtr GetNodeOnAttrib(XML_NodePtr pRoot, CComBSTR bstrName, CComVariant vValue);

wstring		GetSelectedNodeAttribute(XML_NodePtr pParent, const wstring& sSelect, const wstring& sAttribName);
wstring		GetNodeName(XML_NodePtr spNode);

wstring		GetAttribute(XML_NodePtr pNode, const wstring& sAttrName);

CComVariant GetChildNodeText(XML_NodePtr pParent, CComBSTR bstrChildNodeName);

void		SetChildNodeText(XML_NodePtr pParent, CComBSTR bstrChildNodeName, CComVariant vValue);

XML_NodePtr CreateDOMTextNode(XML_DocumentPtr pDoc, CComBSTR bstrName, CComVariant vContents);
XML_NodePtr CreateDOMNode(XML_DocumentPtr pDoc, int type, CComBSTR bstrName);
XML_NodePtr CreateDOMNode(XML_DocumentPtr spDoc, const wstring& sName);

XML_NodePtr AppendTextNode(XML_DocumentPtr spDoc, XML_NodePtr spParent, CComBSTR bstrName, CComVariant vContents);
XML_NodePtr AppendCDATANode(XML_DocumentPtr spDoc, XML_NodePtr spParent, CComBSTR bstrName, CComVariant vContents);
XML_NodePtr AppendNode(XML_DocumentPtr spDoc, XML_NodePtr spParent, CComBSTR bstrName);

CComBSTR	VarToText(const VARIANT& var);
long		VarToLong(const VARIANT& var);
double		VarToDouble(const VARIANT& var);

}; // namespace m

// ----------------------------------------------------------------------- //
#else
#pragma message("--* MSXMLImport.h already included")
#endif
// ----------------------------------------------------------------------- //
