// ==============================================================
// Name:		x2c - funcs.h
//
// Description:	helper functions
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#ifndef FUNCS_H
#define FUNCS_H
#pragma message("--- funcs.h")

#pragma message("- begin includes - " __FILE__)

#include <iostream>
#include <fstream>
#include <string>
#include "MSXMLImport.h"

#pragma message("- end includes - " __FILE__)

using std::ofstream;
//using std::string;
using std::wstring;

// ----------------------------------------------------------------------- //

namespace f
{
	wstring	addDefaultPath(const wstring sName, const wstring sDefaultPath);
	wstring	getPath(const wstring sName);
	wstring::size_type findExtension(const wstring sName);
	wstring	removeExtension(const wstring sName);
	wstring	addDefaultExtension(const wstring sName, const wstring sDefaultExtension);
	wstring	replaceExtension(const wstring sName, const wstring sNewExtension);
	wstring	xmlEscape(const wstring& sInput);
	void	makeDirectory(const wstring& sDirName);
	void	openPackageStream(ofstream* os, const wstring& sPackageDir,
								const wstring& sPackageName, const wstring& sObjectName);
	wstring	pathConcat(const wstring& lhs, const wstring& rhs);
	m::XML_DocumentPtr openXmlDoc(const wstring& sFileName);
	wstring	stripQuotes(const wstring& sInput);
	wstring	getlastsyserr(const wstring& sFormat);
	wstring	getlastsyserr();
	wstring	v2s(const wchar_t* pszFormat, ...);
};


// ----------------------------------------------------------------------- //
#else
#pragma message("--* funcs.h already included")
#endif
// ----------------------------------------------------------------------- //
