// ==============================================================
// Name:		x2c - generator.cpp
//
// Description:	main generator object, runs the whole shebang
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#include "stdafx.h"
#pragma warning(disable:4786)
#include <iostream>
#include <fstream>
#include "exceptions.h"
#include "filelex.h"
#include "parse.h"
#include "pstore.h"
#include "generator.h"

using std::endl;

using std::wifstream;
using std::wcout;

// ------------------------------------------------------------------------- //

CGenerator::CGenerator(const wstring& sTemplateFile) :
m_sTemplateFile(sTemplateFile)
{}

CGenerator::~CGenerator()
{}

// ------------------------------------------------------------------------- //

void CGenerator::run()
{
	try
	{
		CFileLex lex(m_sTemplateFile);

		// run parser as rootparser (main parser of the template)
		CParse parse;
		parse.run(&lex);
	}
	catch(const x::lexerror& e)
	{
		wcout << L"Runtime error: " << e.msg() << endl;
	}
}
