// ==============================================================
// Name:		x2c - nodelist.h
//
// Description:	maintains a list of XML nodes
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================

#ifndef NODELIST_H
#define NODELIST_H
#pragma message("--- nodelist.h")

#pragma message("- begin includes - " __FILE__)
#include <vector>
#include "MSXMLImport.h"
#include "rcptr.h"
#pragma message("- end includes - " __FILE__)

using std::vector;

using m::XML_NodePtr;
using m::XML_NodelistPtr;

// ----------------------------------------------------------------------- //

class CNodelist : public rcBase<CNodelist>
{
public:
	class iterator
	{
	public:
		iterator(CNodelist& rNL, long lIndex);
		iterator& operator++();
		XML_NodePtr operator*();
		bool operator==(const iterator& rhs);
		bool operator!=(const iterator& rhs);
	private:
		long		m_lIndex;
		CNodelist&	m_parent;
	};

	friend class CNodelist::iterator;

	CNodelist();
	CNodelist(XML_NodePtr spNode, const wstring& sPathExpr);
	CNodelist(XML_NodelistPtr spNodelist);
	virtual ~CNodelist();
	//XML_NodelistPtr get()	{ return m_spNodelist; }
	iterator begin();
	iterator end();
	bool empty() const;
protected:
	void loadFromNodelist(XML_NodelistPtr spNodelist);
private:
	vector<XML_NodePtr>	m_vNodes;

};

typedef rcPtr<CNodelist> CNodelistRcp;

// ----------------------------------------------------------------------- //
#else
#pragma message("--* nodelist.h already included")
#endif
// ----------------------------------------------------------------------- //
