// ==============================================================
// Name:		x2c - pstore.h
//
// Description:	p-code store - holds tokens as read by the lexer in tokenized format
//				and can load and save these to tokenized semicompiled files
//				(except, actually, I don't think this is used, but wtf)
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================



// pstore.h
//
// p-code store - holds tokens as read by the lexer in tokenized format
// and can load and save these to tokenized semicompiled files

class psimpl;

class CpStore
{
public:
	CpStore();
	virtual ~CpStore();

	// tokenized file
	void load(const wstring& sTokenFileName);
	void save(const wstring& sTokenFileName);

	// scan and load from source lexer
	void load(CLex* pLex);

	// parser uses these
	token getToken(long lIndex);
	const wstring& getString(long lIndex);

private:
	psimpl* m_pimpl;
};


