// ==============================================================
// Name:		stringlex.h
//
// Description:	x2c - lexer for in memory string input
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#ifndef STRINGLEX_H
#define STRINGLEX_H
#pragma message("--- stringlex.h")

#pragma message("- begin includes - " __FILE__)
#include <string>
#include <vector>
#include <map>
#pragma message("- end includes - " __FILE__)

//using std::string;
using std::wstring;
using std::vector;
using std::map;

// ----------------------------------------------------------------------- //

typedef vector<long>		t_vLng;
typedef map<wstring,long>	t_mStrLng;

class CStringLex : public CLex
{
public:
	CStringLex(const wstring& sInput);
	virtual ~CStringLex();

	void	savepos();
	void	restorepos();
	void	disposepos();
	void	restart();
	void	savepos(const wstring& sPosName);
	void	restorepos(const wstring& sPosName);
	void	skipWhite();
	wstring	getPositionDescription() const;
	wstring	readToString(const wstring& s);


protected:

private:
	wstring		m_sInput;
	t_vLng		m_vCharPos;
	t_mStrLng	m_mNamedPos;
};


// ----------------------------------------------------------------------- //
#else
#pragma message("--* stringlex.h already included")
#endif
// ----------------------------------------------------------------------- //
