// ==============================================================
// Name:		userfunc.h
//
// Description:	x2c - implements user defined functions
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#ifndef USERFUNC_H
#define USERFUNC_H
#pragma message("--- userfunc.h")

#pragma message("- begin includes - " __FILE__)
#include <vector>
#include <iostream>
#include <fstream>
//#include "constants.h"
#pragma message("- end includes - " __FILE__)

using std::vector;
using std::pair;
using std::make_pair;
using std::ofstream;

// ----------------------------------------------------------------------- //

typedef pair<token,wstring>	t_pTokStr;
typedef vector<t_pTokStr>	t_vpTokStr;

class CUserFunc : public CFunctorBase
{
public:
	CUserFunc(const wstring& sFuncName, eValType vtReturns, t_vpVtStr vpParams, CLex* pLex);
	virtual ~CUserFunc();
//	void addParam(token tParamType, const string& sParamName);
	virtual void operator()(CValStack* pvs, CSymbols& symbols, CParse* pRootParser);
private:
//	string			m_sFuncName;
//	t_vpTokStr		m_vTokStr;		// left-to-right parameter types and names
	CLex*			m_pLex;			// the same lexer during pre-scan as runtime
};


// ----------------------------------------------------------------------- //
#else
#pragma message("--* userfunc.h already included")
#endif
// ----------------------------------------------------------------------- //
