// ==============================================================
// Name:		vmap.h
//
// Description:	x2c - value map
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#include <string>
#include <map>
#include "rcptr.h"

using std::string;
using std::wstring;
using std::map;
using std::make_pair;

typedef map<wstring,wstring>	t_mStrStr;


class CVMap : public rcBase<CVMap>
{
public:
	class iterator
	{
	public:
		iterator(t_mStrStr::iterator);
		virtual ~iterator();
		bool operator==(const iterator& rhs) const;
		bool operator!=(const iterator& rhs) const;
		iterator& operator++();
		const wstring& getKey() const;
		const wstring& getValue() const;
	private:
		t_mStrStr::iterator	m_itr;
	};
	friend class CVMap::iterator;
	CVMap();
	virtual ~CVMap();
	void add(const wstring& sKey, const wstring& sValue);
	void setDef(const wstring& sDefVal);
	void setErrDefault();
	void setCopyDefault();
	wstring lookup(const wstring& sKey);
	iterator begin();
	iterator end();
private:
	enum deflt {dSTR, dERR, dCOPY};
	t_mStrStr			m_mStrStr;
	deflt				m_deflt;
	wstring				m_sDefVal;
};

typedef rcPtr<CVMap> CVMapRcp;
