// ==============================================================
// Name:		x2c - vset.cpp
//
// Description:	implements the set data type
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#include "stdafx.h"
#include "vset.h"

// --------------------------------------------------

CVSet::iterator::iterator(t_sStr::iterator itr) :
m_itr(itr) {}

CVSet::iterator::~iterator()
{}

bool CVSet::iterator::operator !=(const iterator& rhs) const
{
	return rhs.m_itr != m_itr;
}

bool CVSet::iterator::operator ==(const iterator& rhs) const
{
	return rhs.m_itr == m_itr;
}

const wstring& CVSet::iterator::operator *() const
{
	return *m_itr;
}

CVSet::iterator& CVSet::iterator::operator ++()
{
	++m_itr;
	return *this;
}

// ----------------------------------------------------

CVSet::CVSet()
{}

CVSet::CVSet(const CVSet& src) :
m_set(src.m_set)
{}

CVSet::~CVSet()
{}

CVSet& CVSet::operator =(const CVSet& rhs)
{
	if (&rhs != this)
		m_set = rhs.m_set;
	return *this;
}

CVSet::iterator CVSet::begin()
{
	return iterator(m_set.begin());
}

CVSet::iterator CVSet::end()
{
	return iterator(m_set.end());
}

void CVSet::insert(const wstring& s)
{
	m_set.insert(s);
}

void CVSet::insert(CVSet& src)
{
	for (CVSet::iterator itr = src.begin(); itr != src.end(); ++itr)
	{
		insert(*itr);
	}
}

void CVSet::erase(const wstring& s)
{
	m_set.erase(s);
}

void CVSet::erase(CVSet& src)
{
	for (CVSet::iterator itr = src.begin(); itr != src.end(); ++itr)
	{
		erase(*itr);
	}
}

bool CVSet::isInSet(const wstring& s)
{
	return m_set.find(s) != m_set.end();
}