// ==============================================================
// Name:		x2c - vxml.cpp
//
// Description:	implements the xml data type
//
// Copyright (C) 2001-2008, J. Martin Wehlou, Man in The Middle AB
// martin@wehlou.com, martin@mitm.se, MiTM AB, Flintstensvagen 10, 75267 Uppsala, Sweden
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// $LastChangedDate: $
// $LastChangedRevision: $
// $LastChangedBy: $
// $HeadURL: $
// $Id: $
// ==============================================================


#include "stdafx.h"
#include "MSXMLImport.h"
#include "funcs.h"
#include "vxml.h"


// ==========================================================================
//  CVXml
// ==========================================================================

CVXml::CVXml(const wstring& sFileName) :
m_sFileName(sFileName)
{
	m_spDoc.CoCreateInstance(__uuidof(MSXML::DOMDocument));
	m_spDoc = f::openXmlDoc(sFileName);
	m_spRoot = m_spDoc->GetdocumentElement();	
}

CVXml::~CVXml()
{
	m_spDoc.Release();
}
